/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "display/renderimpl.h"

#define RENDER_WIDTH_PIXELS 160
#define RENDER_HEIGHT_PIXELS 144
#define RENDER_WIDTH_TILES 20
#define RENDER_HEIGHT_TILES 18

extern uint8_t RENDER_STATUS;
#define RENDER_SHOULD_EXIT (1 << 0)

/**
 * Initializes the rendering system.
 */
void renderInit(void);

/**
 * Vsyncs the frame.
 */
void renderVsync(void);

/**
 * Disposes of the rendering system.
 */
void renderDispose(void);

/**
 * Turns off the display.
 */
void renderDisplayOff(void);

/**
 * Turns on the display.
 */
void renderDisplayOn(void);